#!/bin/sh
# Add mailing list admins (SETADMIN)
#	Copyright 1998 (C) SAITOH-Ely-Yasuhiro.
#	All rights reserved.
#
VERSION=@VER@
DRIVER=@DRIVER@
DOMAIN=@DOMAIN@
PATH=@PATH@
SENDMAIL=@SENDMAIL@
export PATH

umask 022
unset LANG >/dev/null 2>&1

TEMP=/tmp/TEMP.$$
SEND=/tmp/SEND.$$

trap "rm -f $TEMP $SEND ; exit 0" 0 1 2 3 15


if [ $# -ne 2 ]
then
	echo "Usage: setadmin ML-name Email-Address" 1>&2
	exit 1
fi

ML=$1
MAIL=$2

if [ ! -d $DRIVER/$ML ]
then
	echo "setadmin: ML ($ML) not found." 1>&2
	exit 1
fi

. $DRIVER/config.default

if [ -f $DRIVER/$ML/config.$ML ]
then
	. $DRIVER/$ML/config.$ML
fi

if [ ! "$MESSAGES" ]
then
	MESSAGES=messages
fi

ADMINFILE=$DRIVER/$ML/$ML-admins

c=
T="`echo 'test\c'`"
if [ "$T" = "test" ]
then
	c="\c"
fi
n=
T="`echo -n 'test'`"
if [ "$T" = "test" ]
then
	n="-n"
fi

grep -i $MAIL $ADMINFILE >/dev/null 2>&1
if [ $? -eq 0 ]
then
	echo "setadimin: $MAIL is already admins." 1>&2
	echo ""
	echo "Key  Address"
	grep -i $MAIL $ADMINFILE
	exit 1
fi

echo $n "Adding new admin ... $c"

PID=$$
KEY=`expr $PID + $PID`

#KEY=`expr 0000$KEY : '.*\(....\)$'`
KEY=`echo 0000$KEY | sed -e 's/.*\(....\)$/\1/'`
echo "$KEY <$MAIL>" >> $ADMINFILE

egrep -v "[0-9][0-9][0-9][0-9] <.*>" $ADMINFILE | \
	awk '{ printf("%s <%s>\n",$1,$2) }'   > ${ADMINFILE}.wk
egrep "[0-9][0-9][0-9][0-9] <.*>" $ADMINFILE >> ${ADMINFILE}.wk
mv ${ADMINFILE}.wk $ADMINFILE

SEDADD=`echo $MAIL | sed -e 's/\//\\\\\//g'`

echo "s/%AdDrEsS%/$SEDADD/
      s/%CNtLAdRs%/$ML-control@$DOMAIN/
      s/%MlNaMe%/${ML}@${DOMAIN}/
      s/%kEyWd%/$KEY/" > $TEMP

echo "To: $MAIL"                                         > $SEND
echo "From: $ML-request@$DOMAIN ($ML ML admin)"         >> $SEND
echo "Subject: Your address registered $ML ML admins."  >> $SEND
echo "Reply-To: $ML-request@$DOMAIN"                    >> $SEND
echo "Errors-To: $ML-request@$DOMAIN"                   >> $SEND
echo "X-ML-Driver: SETADMIN (Version $VERSION)"         >> $SEND

if [ "$SENDER" ]
then
	echo "Sender: $SENDER"                          >> $SEND
fi

if [ "$PRECEDENCE" ]
then
	echo "Precedence: $PRECEDENCE"                  >> $SEND

fi
echo ""                                                 >> $SEND

sed -f $TEMP < $DRIVER/$MESSAGES/admin                  >> $SEND
sed -f $TEMP < $DRIVER/$MESSAGES/admmanual              >> $SEND

b64decode < $SEND | $SENDMAIL -oi -t -f$ML-request@$DOMAIN

echo "Done."

grep "$ML-request:" /etc/aliases | grep ":include:$DRIVER/$ML/$ML-admins" >/dev/null 2>&1
if [ $? -ne 0 ]
then
	echo "** Information **"
	echo "   You can exchange $ML-request entry in /etc/aliases."
	echo "    ->  $ML-request: :include:$DRIVER/$ML/$ML-admins"
fi

exit 0
